;'use strict';(function(window){var gL10nData={};var gTextProp='textContent';var gLanguage='';var gMacros={};var gReadyState='loading';var gAsyncResourceLoading=true;var gDEBUG=1;function consoleLog(message){if(gDEBUG>=2){console.log('[l10n] '+message);}};function consoleWarn(message){if(gDEBUG){console.warn('[l10n] '+message);}};function getL10nResourceLinks(){return document.querySelectorAll('link[type="application/l10n"]');}
function getL10nDictionary(){var script=document.querySelector('script[type="application/l10n"]');return script?JSON.parse(script.innerHTML):null;}
function getTranslatableChildren(element){return element?element.querySelectorAll('*[data-l10n-id]'):[];}
function getL10nAttributes(element){if(!element)
return{};var l10nId=element.getAttribute('data-l10n-id');var l10nArgs=element.getAttribute('data-l10n-args');var args={};if(l10nArgs){try{args=JSON.parse(l10nArgs);}catch(e){consoleWarn('could not parse arguments for #'+l10nId);}}
return{id:l10nId,args:args};}
function fireL10nReadyEvent(){var evtObject=document.createEvent('Event');evtObject.initEvent('localized',false,false);evtObject.language=gLanguage;window.dispatchEvent(evtObject);}
function parseResource(href,lang,successCallback,failureCallback){var baseURL=href.replace(/\/[^\/]*$/,'/');function evalString(text){if(text.lastIndexOf('\\')<0)
return text;return text.replace(/\\\\/g,'\\').replace(/\\n/g,'\n').replace(/\\r/g,'\r').replace(/\\t/g,'\t').replace(/\\b/g,'\b').replace(/\\f/g,'\f').replace(/\\{/g,'{').replace(/\\}/g,'}').replace(/\\"/g,'"').replace(/\\'/g,"'");}
function parseProperties(text){var dictionary=[];var reBlank=/^\s*|\s*$/;var reComment=/^\s*#|^\s*$/;var reSection=/^\s*\[(.*)\]\s*$/;var reImport=/^\s*@import\s+url\((.*)\)\s*$/i;var reSplit=/^([^=\s]*)\s*=\s*(.+)$/;function parseRawLines(rawText,extendedSyntax){var entries=rawText.replace(reBlank,'').split(/[\r\n]+/);var currentLang='*';var genericLang=lang.replace(/-[a-z]+$/i,'');var skipLang=false;var match='';for(var i=0;i<entries.length;i++){var line=entries[i];if(reComment.test(line))
continue;if(extendedSyntax){if(reSection.test(line)){match=reSection.exec(line);currentLang=match[1];skipLang=(currentLang!=='*')&&(currentLang!==lang)&&(currentLang!==genericLang);continue;}else if(skipLang){continue;}
if(reImport.test(line)){match=reImport.exec(line);loadImport(baseURL+match[1]);}}
var tmp=line.match(reSplit);if(tmp&&tmp.length==3){dictionary[tmp[1]]=evalString(tmp[2]);}}}
function loadImport(url){loadResource(url,function(content){parseRawLines(content,false);},null,false);}
parseRawLines(text,true);return dictionary;}
function loadResource(url,onSuccess,onFailure,asynchronous){onSuccess=onSuccess||function _onSuccess(data){};onFailure=onFailure||function _onFailure(){consoleWarn(url+' not found.');};var xhr=new XMLHttpRequest();xhr.open('GET',url,asynchronous);if(xhr.overrideMimeType){xhr.overrideMimeType('text/plain; charset=utf-8');}
xhr.onreadystatechange=function(){if(xhr.readyState==4){if(xhr.status==200||xhr.status===0){onSuccess(xhr.responseText);}else{onFailure();}}};xhr.onerror=onFailure;xhr.ontimeout=onFailure;try{xhr.send(null);}catch(e){onFailure();}}
loadResource(href,function(response){var data=parseProperties(response);for(var key in data){var id,prop,index=key.lastIndexOf('.');if(index>0){id=key.substring(0,index);prop=key.substr(index+1);}else{id=key;prop=gTextProp;}
if(!gL10nData[id]){gL10nData[id]={};}
gL10nData[id][prop]=data[key];}
if(successCallback){successCallback();}},failureCallback,gAsyncResourceLoading);};function loadLocale(lang,callback){callback=callback||function _callback(){};clear();gLanguage=lang;var langLinks=getL10nResourceLinks();var langCount=langLinks.length;if(langCount==0){var dict=getL10nDictionary();if(dict&&dict.locales&&dict.default_locale){consoleLog('using the embedded JSON directory, early way out');gL10nData=dict.locales[lang]||dict.locales[dict.default_locale];callback();}else{consoleLog('no resource to load, early way out');}
fireL10nReadyEvent(lang);gReadyState='complete';return;}
var onResourceLoaded=null;var gResourceCount=0;onResourceLoaded=function(){gResourceCount++;if(gResourceCount>=langCount){callback();fireL10nReadyEvent(lang);gReadyState='complete';}};function l10nResourceLink(link){var href=link.href;var type=link.type;this.load=function(lang,callback){var applied=lang;parseResource(href,lang,callback,function(){consoleWarn(href+' not found.');applied='';});return applied;};}
for(var i=0;i<langCount;i++){var resource=new l10nResourceLink(langLinks[i]);var rv=resource.load(lang,onResourceLoaded);if(rv!=lang){consoleWarn('"'+lang+'" resource not found');gLanguage='';}}}
function clear(){gL10nData={};gLanguage='';}
function getPluralRules(lang){var locales2rules={'af':3,'ak':4,'am':4,'ar':1,'asa':3,'az':0,'be':11,'bem':3,'bez':3,'bg':3,'bh':4,'bm':0,'bn':3,'bo':0,'br':20,'brx':3,'bs':11,'ca':3,'cgg':3,'chr':3,'cs':12,'cy':17,'da':3,'de':3,'dv':3,'dz':0,'ee':3,'el':3,'en':3,'eo':3,'es':3,'et':3,'eu':3,'fa':0,'ff':5,'fi':3,'fil':4,'fo':3,'fr':5,'fur':3,'fy':3,'ga':8,'gd':24,'gl':3,'gsw':3,'gu':3,'guw':4,'gv':23,'ha':3,'haw':3,'he':2,'hi':4,'hr':11,'hu':0,'id':0,'ig':0,'ii':0,'is':3,'it':3,'iu':7,'ja':0,'jmc':3,'jv':0,'ka':0,'kab':5,'kaj':3,'kcg':3,'kde':0,'kea':0,'kk':3,'kl':3,'km':0,'kn':0,'ko':0,'ksb':3,'ksh':21,'ku':3,'kw':7,'lag':18,'lb':3,'lg':3,'ln':4,'lo':0,'lt':10,'lv':6,'mas':3,'mg':4,'mk':16,'ml':3,'mn':3,'mo':9,'mr':3,'ms':0,'mt':15,'my':0,'nah':3,'naq':7,'nb':3,'nd':3,'ne':3,'nl':3,'nn':3,'no':3,'nr':3,'nso':4,'ny':3,'nyn':3,'om':3,'or':3,'pa':3,'pap':3,'pl':13,'ps':3,'pt':3,'rm':3,'ro':9,'rof':3,'ru':11,'rwk':3,'sah':0,'saq':3,'se':7,'seh':3,'ses':0,'sg':0,'sh':11,'shi':19,'sk':12,'sl':14,'sma':7,'smi':7,'smj':7,'smn':7,'sms':7,'sn':3,'so':3,'sq':3,'sr':11,'ss':3,'ssy':3,'st':3,'sv':3,'sw':3,'syr':3,'ta':3,'te':3,'teo':3,'th':0,'ti':4,'tig':3,'tk':3,'tl':4,'tn':3,'to':0,'tr':0,'ts':3,'tzm':22,'uk':11,'ur':3,'ve':3,'vi':0,'vun':3,'wa':4,'wae':3,'wo':0,'xh':3,'xog':3,'yo':0,'zh':0,'zu':3};function isIn(n,list){return list.indexOf(n)!==-1;}
function isBetween(n,start,end){return start<=n&&n<=end;}
var pluralRules={'0':function(n){return'other';},'1':function(n){if((isBetween((n%100),3,10)))
return'few';if(n===0)
return'zero';if((isBetween((n%100),11,99)))
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'2':function(n){if(n!==0&&(n%10)===0)
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'3':function(n){if(n==1)
return'one';return'other';},'4':function(n){if((isBetween(n,0,1)))
return'one';return'other';},'5':function(n){if((isBetween(n,0,2))&&n!=2)
return'one';return'other';},'6':function(n){if(n===0)
return'zero';if((n%10)==1&&(n%100)!=11)
return'one';return'other';},'7':function(n){if(n==2)
return'two';if(n==1)
return'one';return'other';},'8':function(n){if((isBetween(n,3,6)))
return'few';if((isBetween(n,7,10)))
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'9':function(n){if(n===0||n!=1&&(isBetween((n%100),1,19)))
return'few';if(n==1)
return'one';return'other';},'10':function(n){if((isBetween((n%10),2,9))&&!(isBetween((n%100),11,19)))
return'few';if((n%10)==1&&!(isBetween((n%100),11,19)))
return'one';return'other';},'11':function(n){if((isBetween((n%10),2,4))&&!(isBetween((n%100),12,14)))
return'few';if((n%10)===0||(isBetween((n%10),5,9))||(isBetween((n%100),11,14)))
return'many';if((n%10)==1&&(n%100)!=11)
return'one';return'other';},'12':function(n){if((isBetween(n,2,4)))
return'few';if(n==1)
return'one';return'other';},'13':function(n){if((isBetween((n%10),2,4))&&!(isBetween((n%100),12,14)))
return'few';if(n!=1&&(isBetween((n%10),0,1))||(isBetween((n%10),5,9))||(isBetween((n%100),12,14)))
return'many';if(n==1)
return'one';return'other';},'14':function(n){if((isBetween((n%100),3,4)))
return'few';if((n%100)==2)
return'two';if((n%100)==1)
return'one';return'other';},'15':function(n){if(n===0||(isBetween((n%100),2,10)))
return'few';if((isBetween((n%100),11,19)))
return'many';if(n==1)
return'one';return'other';},'16':function(n){if((n%10)==1&&n!=11)
return'one';return'other';},'17':function(n){if(n==3)
return'few';if(n===0)
return'zero';if(n==6)
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'18':function(n){if(n===0)
return'zero';if((isBetween(n,0,2))&&n!==0&&n!=2)
return'one';return'other';},'19':function(n){if((isBetween(n,2,10)))
return'few';if((isBetween(n,0,1)))
return'one';return'other';},'20':function(n){if((isBetween((n%10),3,4)||((n%10)==9))&&!(isBetween((n%100),10,19)||isBetween((n%100),70,79)||isBetween((n%100),90,99)))
return'few';if((n%1000000)===0&&n!==0)
return'many';if((n%10)==2&&!isIn((n%100),[12,72,92]))
return'two';if((n%10)==1&&!isIn((n%100),[11,71,91]))
return'one';return'other';},'21':function(n){if(n===0)
return'zero';if(n==1)
return'one';return'other';},'22':function(n){if((isBetween(n,0,1))||(isBetween(n,11,99)))
return'one';return'other';},'23':function(n){if((isBetween((n%10),1,2))||(n%20)===0)
return'one';return'other';},'24':function(n){if((isBetween(n,3,10)||isBetween(n,13,19)))
return'few';if(isIn(n,[2,12]))
return'two';if(isIn(n,[1,11]))
return'one';return'other';}};var index=locales2rules[lang.replace(/-.*$/,'')];if(!(index in pluralRules)){consoleWarn('plural form unknown for ['+lang+']');return function(){return'other';};}
return pluralRules[index];}
gMacros.plural=function(str,param,key,prop){var n=parseFloat(param);if(isNaN(n))
return str;if(prop!=gTextProp)
return str;if(!gMacros._pluralRules){gMacros._pluralRules=getPluralRules(gLanguage);}
var index='['+gMacros._pluralRules(n)+']';if(n===0&&(key+'[zero]')in gL10nData){str=gL10nData[key+'[zero]'][prop];}else if(n==1&&(key+'[one]')in gL10nData){str=gL10nData[key+'[one]'][prop];}else if(n==2&&(key+'[two]')in gL10nData){str=gL10nData[key+'[two]'][prop];}else if((key+index)in gL10nData){str=gL10nData[key+index][prop];}else if((key+'[other]')in gL10nData){str=gL10nData[key+'[other]'][prop];}
return str;};function getL10nData(key,args){var data=gL10nData[key];if(!data){consoleWarn('#'+key+' is undefined.');}
var rv={};for(var prop in data){var str=data[prop];str=substIndexes(str,args,key,prop);str=substArguments(str,args,key);rv[prop]=str;}
return rv;}
function substIndexes(str,args,key,prop){var reIndex=/\{\[\s*([a-zA-Z]+)\(([a-zA-Z]+)\)\s*\]\}/;var reMatch=reIndex.exec(str);if(!reMatch||!reMatch.length)
return str;var macroName=reMatch[1];var paramName=reMatch[2];var param;if(args&&paramName in args){param=args[paramName];}else if(paramName in gL10nData){param=gL10nData[paramName];}
if(macroName in gMacros){var macro=gMacros[macroName];str=macro(str,param,key,prop);}
return str;}
function substArguments(str,args,key){var reArgs=/\{\{\s*(.+?)\s*\}\}/;var match=reArgs.exec(str);while(match){if(!match||match.length<2)
return str;var arg=match[1];var sub='';if(args&&arg in args){sub=args[arg];}else if(arg in gL10nData){sub=gL10nData[arg][gTextProp];}else{consoleLog('argument {{'+arg+'}} for #'+key+' is undefined.');return str;}
str=str.substring(0,match.index)+sub+
str.substr(match.index+match[0].length);match=reArgs.exec(str);}
return str;}
function translateElement(element){var l10n=getL10nAttributes(element);if(!l10n.id){return;}
var data=getL10nData(l10n.id,l10n.args);if(!data){consoleWarn('#'+l10n.id+' is undefined.');return;}
if(data[gTextProp]){if(element.children.length===0){element[gTextProp]=data[gTextProp];}else{var children=element.childNodes;var found=false;for(var i=0,l=children.length;i<l;i++){if(children[i].nodeType===3&&/\S/.test(children[i].nodeValue)){if(found){children[i].nodeValue='';}else{children[i].nodeValue=data[gTextProp];found=true;}}}
if(!found){var textNode=document.createTextNode(data[gTextProp]);element.insertBefore(textNode,element.firstChild);}}
delete data[gTextProp];}
for(var k in data){element[k]=data[k];}}
function translateFragment(element){element=element||document.documentElement;var children=getTranslatableChildren(element);var elementCount=children.length;for(var i=0;i<elementCount;i++){translateElement(children[i]);}
translateElement(element);}
function l10nStartup(){gReadyState='interactive';consoleLog('loading ['+navigator.language+'] resources, '+
(gAsyncResourceLoading?'asynchronously.':'synchronously.'));if(document.documentElement.lang===navigator.language){loadLocale(navigator.language);}else{loadLocale(navigator.language,translateFragment);}}
if(typeof(document)!=='undefined'){if(document.readyState==='complete'||document.readyState==='interactive'){window.setTimeout(l10nStartup);}else{document.addEventListener('DOMContentLoaded',l10nStartup);}}
if('mozSettings'in navigator&&navigator.mozSettings){navigator.mozSettings.addObserver('language.current',function(event){loadLocale(event.settingValue,translateFragment);});}
navigator.mozL10n={get:function l10n_get(key,args,fallback){var data=getL10nData(key,args)||fallback;if(data){return'textContent'in data?data.textContent:'';}
return'{{'+key+'}}';},get language(){return{get code(){return gLanguage;},set code(lang){loadLocale(lang,translateFragment);},get direction(){var rtlList=['ar','he','fa','ps','ur'];return(rtlList.indexOf(gLanguage)>=0)?'rtl':'ltr';}};},translate:translateFragment,get dictionary(){return JSON.parse(JSON.stringify(gL10nData));},get readyState(){return gReadyState;},ready:function l10n_ready(callback){if(!callback){return;}else if(gReadyState=='complete'||gReadyState=='interactive'){window.setTimeout(callback);}else{window.addEventListener('localized',callback);}}};consoleLog('library loaded.');})(this);;'use strict';var LazyLoader=(function(){function LazyLoader(){this._loaded={};this._isLoading={};}
LazyLoader.prototype={_js:function(file,callback){var script=document.createElement('script');script.src=file;script.addEventListener('load',callback);document.head.appendChild(script);this._isLoading[file]=script;},_css:function(file,callback){var style=document.createElement('link');style.type='text/css';style.rel='stylesheet';style.href=file;document.head.appendChild(style);callback();},_html:function(domNode,callback){for(var i=0;i<domNode.childNodes.length;i++){if(domNode.childNodes[i].nodeType==document.COMMENT_NODE){domNode.innerHTML=domNode.childNodes[i].nodeValue;break;}}
callback();},load:function(files,callback){if(!Array.isArray(files))
files=[files];var loadsRemaining=files.length,self=this;function perFileCallback(file){if(self._isLoading[file])
delete self._isLoading[file];self._loaded[file]=true;if(--loadsRemaining===0){if(callback)
callback();}}
for(var i=0;i<files.length;i++){var file=files[i];if(this._loaded[file]){perFileCallback(file);}else if(this._isLoading[file]){this._isLoading[file].addEventListener('load',perFileCallback.bind(null,file));}else{var method,idx;if(typeof file==='string'){method=file.match(/\.(.*?)$/)[1];idx=file;}else{method='html';idx=file.id;}
this['_'+method](file,perFileCallback.bind(null,idx));}}}};return new LazyLoader();}());;'use strict';var loader=LazyLoader;function padLeft(num,length){var r=String(num);while(r.length<length){r='0'+r;}
return r;}
var DCFApi=(function(){var api={};var dcfConfigLoaded=false;var deferredArgs=null;var defaultSeq={file:1,dir:100};var dcfConfig={key:'dcf_key',seq:null,postFix:'MZLLA',prefix:{video:'VID_',image:'IMG_'},ext:{video:'3gp',image:'jpg'}};api.init=function(){asyncStorage.getItem(dcfConfig.key,function(value){dcfConfigLoaded=true;dcfConfig.seq=value?value:defaultSeq;if(deferredArgs){var args=deferredArgs;api.createDCFFilename(args.storage,args.type,args.callback);deferredArgs=null;}});};api.createDCFFilename=function(storage,type,callback){if(!dcfConfigLoaded){deferredArgs={storage:storage,type:type,callback:callback};return;}
var filepath='DCIM/'+dcfConfig.seq.dir+dcfConfig.postFix+'/';var filename=dcfConfig.prefix[type]+
padLeft(dcfConfig.seq.file,4)+'.'+
dcfConfig.ext[type];var req=storage.get(filepath+filename);req.onsuccess=function(){dcfConfig.seq.file=1;dcfConfig.seq.dir+=1;asyncStorage.setItem(dcfConfig.key,dcfConfig.seq,function(){api.createDCFFilename(storage,type,callback);});};req.onerror=function(){if(dcfConfig.seq.file<9999){dcfConfig.seq.file+=1;}else{dcfConfig.seq.file=1;dcfConfig.seq.dir+=1;}
asyncStorage.setItem(dcfConfig.key,dcfConfig.seq,function(){callback(filepath,filename);});};};return api;})();var Camera={_cameras:null,_camera:0,_captureMode:null,_recording:false,_secureMode:window.parent!==window,_currentOverlay:null,CAMERA:'camera',VIDEO:'video',_videoTimer:null,_videoStart:null,_videoPath:null,_autoFocusSupported:0,_manuallyFocused:false,_timeoutId:0,_cameraObj:null,_photosTaken:[],_cameraProfile:null,_resumeViewfinderTimer:null,_waitingToGenerateThumb:false,_styleSheet:document.styleSheets[0],_orientationRule:null,_phoneOrientation:0,_pictureStorage:null,_videoStorage:null,_storageState:null,STORAGE_INIT:0,STORAGE_AVAILABLE:1,STORAGE_NOCARD:2,STORAGE_UNMOUNTED:3,STORAGE_CAPACITY:4,_pictureSize:null,_previewPaused:false,_previewActive:false,PREVIEW_PAUSE:500,FILMSTRIP_DURATION:5000,_flashModes:[],_currentFlashMode:0,_config:{fileFormat:'jpeg'},get _previewConfig(){delete this._previewConfig;return this._previewConfig={width:document.body.clientHeight,height:document.body.clientWidth};},_previewConfigVideo:{profile:'cif',rotation:0,width:352,height:288},_shutterKey:'camera.shutter.enabled',_shutterSound:null,_shutterSoundEnabled:true,PROMPT_DELAY:2000,_watchId:null,_position:null,_pendingPick:null,RECORD_SPACE_MIN:1024*1024*2,RECORD_SPACE_PADDING:1024*1024*1,MAX_IMAGE_RES:1600*1200,get overlayTitle(){return document.getElementById('overlay-title');},get overlayText(){return document.getElementById('overlay-text');},get overlay(){return document.getElementById('overlay');},get viewfinder(){return document.getElementById('viewfinder');},get switchButton(){return document.getElementById('switch-button');},get captureButton(){return document.getElementById('capture-button');},get galleryButton(){return document.getElementById('gallery-button');},get videoTimer(){return document.getElementById('video-timer');},get focusRing(){return document.getElementById('focus-ring');},get toggleButton(){return document.getElementById('toggle-camera');},get toggleFlashBtn(){return document.getElementById('toggle-flash');},init:function(){var self=this;this.setCaptureMode(this.CAMERA);this.loadCameraPreview(this._camera,function(){var files=['style/filmstrip.css','style/VideoPlayer.css','/shared/js/async_storage.js','/shared/js/blobview.js','/shared/js/media/jpeg_metadata_parser.js','/shared/js/media/get_video_rotation.js','/shared/js/media/video_player.js','/shared/js/media/media_frame.js','/shared/js/gesture_detector.js','js/filmstrip.js'];loader.load(files,function(){self.delayedInit();});});},delayedInit:function camera_delayedInit(){if(!navigator.mozHasPendingMessage('activity')){this.galleryButton.classList.remove('hidden');this.switchButton.classList.remove('hidden');this.enableButtons();}
if(navigator.requestWakeLock){navigator.requestWakeLock('screen');}
this.setToggleCameraStyle();var css='#switch-button span, #capture-button span, '+'#gallery-button span { -moz-transform: rotate(0deg); }';var insertId=this._styleSheet.cssRules.length-1;this._orientationRule=this._styleSheet.insertRule(css,insertId);window.addEventListener('deviceorientation',this.orientChange.bind(this));this.toggleButton.addEventListener('click',this.toggleCamera.bind(this));this.toggleFlashBtn.addEventListener('click',this.toggleFlash.bind(this));this.viewfinder.addEventListener('click',this.toggleFilmStrip.bind(this));this.switchButton.addEventListener('click',this.toggleModePressed.bind(this));this.captureButton.addEventListener('click',this.capturePressed.bind(this));this.galleryButton.addEventListener('click',this.galleryBtnPressed.bind(this));if(!navigator.mozCameras){this.captureButton.setAttribute('disabled','disabled');return;}
if(this._secureMode){this.galleryButton.setAttribute('disabled','disabled');}
this._shutterSound=new Audio('./resources/sounds/shutter.ogg');this._shutterSound.mozAudioChannelType='publicnotification';if('mozSettings'in navigator){var req=navigator.mozSettings.createLock().get(this._shutterKey);req.onsuccess=(function onsuccess(){this._shutterSoundEnabled=req.result[this._shutterKey];}).bind(this);navigator.mozSettings.addObserver(this._shutterKey,(function(e){this._shutterSoundEnabled=e.settingValue;}).bind(this));}
this._storageState=this.STORAGE_INIT;this._pictureStorage=navigator.getDeviceStorage('pictures');this._videoStorage=navigator.getDeviceStorage('videos'),this._pictureStorage.addEventListener('change',this.deviceStorageChangeHandler.bind(this));this.checkStorageSpace();navigator.mozSetMessageHandler('activity',function(activity){var name=activity.source.name;if(name==='pick'){Camera.initPick(activity);}
else{Camera.galleryButton.classList.remove('hidden');Camera.switchButton.classList.remove('hidden');}
Camera.enableButtons();});this.previewEnabled();DCFApi.init();},enableButtons:function camera_enableButtons(){if(!this._pendingPick){this.switchButton.removeAttribute('disabled');}
this.captureButton.removeAttribute('disabled');},disableButtons:function camera_disableButtons(){this.switchButton.setAttribute('disabled','disabled');this.captureButton.setAttribute('disabled','disabled');},initPick:function camera_initPick(activity){this._pendingPick=activity;this.galleryButton.classList.add('hidden');this.switchButton.classList.add('hidden');var cancelButton=document.getElementById('cancel-pick');cancelButton.classList.remove('hidden');cancelButton.onclick=this.cancelPick.bind(this);},cancelPick:function camera_cancelPick(){if(this._pendingPick){this._pendingPick.postError('pick cancelled');}
this._pendingPick=null;},toggleModePressed:function camera_toggleCaptureMode(e){if(e.target.getAttribute('disabled')){return;}
var newMode=(this.captureMode===this.CAMERA)?this.VIDEO:this.CAMERA;this.disableButtons();this.setCaptureMode(newMode);function gotPreviewStream(stream){this.viewfinder.mozSrcObject=stream;this.viewfinder.play();this.enableButtons();}
if(this.captureMode===this.CAMERA){this._cameraObj.getPreviewStream(this._previewConfig,gotPreviewStream.bind(this));}else{this._previewConfigVideo.rotation=this._phoneOrientation;this._cameraObj.getPreviewStreamVideoMode(this._previewConfigVideo,gotPreviewStream.bind(this));}},toggleCamera:function camera_toggleCamera(){this._camera=1-this._camera;this.loadCameraPreview(this._camera,this.enableButtons.bind(this));this.setToggleCameraStyle();},setToggleCameraStyle:function camera_setToggleCameraStyle(){var modeName=this._camera===0?'back':'front';this.toggleButton.setAttribute('data-mode',modeName);},toggleFlash:function camera_toggleFlash(){if(this._currentFlashMode===this._flashModes.length-1){this._currentFlashMode=0;}else{this._currentFlashMode=this._currentFlashMode+1;}
this.setFlashMode();},setFlashMode:function camera_setFlashMode(){var flashModeName=this._flashModes[this._currentFlashMode];this.toggleFlashBtn.setAttribute('data-mode',flashModeName);this._cameraObj.flashMode=flashModeName;},toggleRecording:function camera_toggleRecording(){if(this._recording){this.stopRecording();return;}
this.startRecording();},startRecording:function camera_startRecording(){var captureButton=this.captureButton;var switchButton=this.switchButton;var onerror=function(){handleError('error-recording');};var onsuccess=(function onsuccess(){document.body.classList.add('capturing');captureButton.removeAttribute('disabled');this._recording=true;this.startRecordingTimer();if(Filmstrip.isShown())
Filmstrip.hide();if(document.mozHidden){this.stopRecording();}}).bind(this);var handleError=(function handleError(id){this.enableButtons();alert(navigator.mozL10n.get(id+'-title')+'. '+
navigator.mozL10n.get(id+'-text'));}).bind(this);this.disableButtons();var startRecording=(function startRecording(freeBytes){if(freeBytes<this.RECORD_SPACE_MIN){handleError('nospace');return;}
var config={rotation:this._phoneOrientation,maxFileSizeBytes:freeBytes-this.RECORD_SPACE_PADDING};this._cameraObj.startRecording(config,this._videoStorage,this._videoPath,onsuccess,onerror);}).bind(this);DCFApi.createDCFFilename(this._videoStorage,'video',(function(path,name){this._videoPath=path+name;var dummyblob=new Blob([''],{type:'video/3gpp'});var dummyfilename=path+'.'+name;var req=this._videoStorage.addNamed(dummyblob,dummyfilename);req.onerror=onerror;req.onsuccess=(function fileCreated(){this._videoStorage.delete(dummyfilename);var spaceReq=this._videoStorage.freeSpace();spaceReq.onerror=onerror;spaceReq.onsuccess=function(){startRecording(spaceReq.result);};}).bind(this);}).bind(this));},startRecordingTimer:function camera_startRecordingTimer(){this._videoStart=new Date().getTime();this.videoTimer.textContent=this.formatTimer(0);this._videoTimer=window.setInterval(this.updateVideoTimer.bind(this),1000);},updateVideoTimer:function camera_updateVideoTimer(){var videoLength=Math.round((new Date().getTime()-this._videoStart)/1000);this.videoTimer.textContent=this.formatTimer(videoLength);},stopRecording:function camera_stopRecording(){this._cameraObj.stopRecording();this._recording=false;window.clearInterval(this._videoTimer);this.enableButtons();document.body.classList.remove('capturing');var videofile=this._videoPath;setTimeout(function(){Filmstrip.addVideo(videofile);Filmstrip.show(Camera.FILMSTRIP_DURATION);},1000);},formatTimer:function camera_formatTimer(time){var minutes=Math.floor(time/60);var seconds=Math.round(time%60);if(minutes<60){return padLeft(minutes,2)+':'+padLeft(seconds,2);}
return'';},capturePressed:function camera_doCapture(e){if(e.target.getAttribute('disabled')){return;}
if(this.captureMode===this.CAMERA){this.prepareTakePicture();}else{this.toggleRecording();}},galleryBtnPressed:function camera_galleryBtnPressed(){if(this._secureMode)
return;var a=new MozActivity({name:'browse',data:{type:'photos'}});},orientChange:function camera_orientChange(e){var orientation=(e.beta>45)?180:(e.beta<-45)?0:(e.gamma<-45)?90:(e.gamma>45)?270:0;if(orientation!==this._phoneOrientation){var rule=this._styleSheet.cssRules[this._orientationRule];rule.style.MozTransform='rotate('+-(orientation+1)+'deg)';this._phoneOrientation=orientation;Filmstrip.setOrientation(orientation);}},setCaptureMode:function camera_setCaptureMode(mode){if(this.captureMode){document.body.classList.remove(this.captureMode);}
this.captureMode=mode;document.body.classList.add(mode);},toggleFilmStrip:function camera_toggleFilmStrip(ev){if(this._recording)
return;if(Filmstrip.isShown())
Filmstrip.hide();else
Filmstrip.show();},loadCameraPreview:function camera_loadCameraPreview(camera,callback){this.viewfinder.mozSrcObject=null;this._timeoutId=0;var viewfinder=this.viewfinder;var style=viewfinder.style;var width=document.body.clientHeight;var height=document.body.clientWidth;style.top=((width/2)-(height/2))+'px';style.left=-((width/2)-(height/2))+'px';var transform='rotate(90deg)';var rotation;if(camera==1){transform+=' scale(-1, 1)';rotation=0;}else{rotation=0;}
style.MozTransform=transform;style.width=width+'px';style.height=height+'px';this._cameras=navigator.mozCameras.getListOfCameras();var options={camera:this._cameras[this._camera]};function gotPreviewScreen(stream){viewfinder.mozSrcObject=stream;viewfinder.play();if(callback){callback();}
this._previewActive=true;}
function gotCamera(camera){this._cameraObj=camera;this._config.rotation=rotation;this._autoFocusSupported=camera.capabilities.focusModes.indexOf('auto')!==-1;this._pictureSize=this.pickPictureSize(camera.capabilities.pictureSizes);this.enableCameraFeatures(camera.capabilities);camera.onShutter=(function(){if(this._shutterSoundEnabled){this._shutterSound.play();}}).bind(this);camera.onRecorderStateChange=this.recordingStateChanged.bind(this);if(this.captureMode===this.CAMERA){camera.getPreviewStream(this._previewConfig,gotPreviewScreen.bind(this));}else{this._previewConfigVideo.rotation=this._phoneOrientation;this._cameraObj.getPreviewStreamVideoMode(this._previewConfigVideo,gotPreviewScreen.bind(this));}}
if(this._cameraObj){this.release(function camera_release_callback(){navigator.mozCameras.getCamera(options,gotCamera.bind(this));});}else{navigator.mozCameras.getCamera(options,gotCamera.bind(this));}},recordingStateChanged:function(msg){if(msg==='FileSizeLimitReached'){this.stopRecording();alert(navigator.mozL10n.get('size-limit-reached'));}},enableCameraFeatures:function camera_enableCameraFeatures(capabilities){if(this._cameras.length>1){this.toggleButton.classList.remove('hidden');}else{this.toggleButton.classList.add('hidden');}
this._flashModes=capabilities.flashModes;if(this._flashModes){this.setFlashMode();this.toggleFlashBtn.classList.remove('hidden');}else{this.toggleFlashBtn.classList.add('hidden');}},startPreview:function camera_startPreview(){this.viewfinder.play();this.loadCameraPreview(this._camera,this.previewEnabled.bind(this));this._previewActive=true;},previewEnabled:function(){this.enableButtons();setTimeout(this.initPositionUpdate.bind(this),this.PROMPT_DELAY);},stopPreview:function camera_stopPreview(){if(this._recording){this.stopRecording();}
this.disableButtons();this.viewfinder.pause();this._previewActive=false;this.viewfinder.mozSrcObject=null;this.release();},resumePreview:function camera_resumePreview(){this._cameraObj.resumePreview();this._previewActive=true;this.enableButtons();},restartPreview:function camera_restartPreview(){this._resumeViewfinderTimer=window.setTimeout(this.resumePreview.bind(this),this.PREVIEW_PAUSE);},takePictureSuccess:function camera_takePictureSuccess(blob){this._config.position=null;this._manuallyFocused=false;this.hideFocusRing();this.restartPreview();DCFApi.createDCFFilename(this._pictureStorage,'image',(function(path,name){var addreq=this._pictureStorage.addNamed(blob,path+name);addreq.onsuccess=(function(){if(this._pendingPick){this._resizeBlobIfNeeded(blob,function(resized_blob){this._pendingPick.postResult({type:'image/jpeg',blob:resized_blob});this._pendingPick=null;}.bind(this));return;}
Filmstrip.addImage(path+name,blob);Filmstrip.show(Camera.FILMSTRIP_DURATION);this.checkStorageSpace();}).bind(this);addreq.onerror=function(){alert(navigator.mozL10n.get('error-saving-title')+'. '+
navigator.mozL10n.get('error-saving-text'));};}).bind(this));},_resizeBlobIfNeeded:function camera_resizeBlobIfNeeded(blob,callback){var pickWidth=this._pendingPick.source.data.width;var pickHeight=this._pendingPick.source.data.height;if(!pickWidth||!pickHeight){callback(blob);return;}
var img=new Image();img.onload=function resizeImg(){var canvas=document.createElement('canvas');canvas.width=pickWidth;canvas.height=pickHeight;var ctx=canvas.getContext('2d');ctx.drawImage(img,0,0,pickWidth,pickHeight);canvas.toBlob(function toBlobSuccess(resized_blob){callback(resized_blob);},'image/jpeg');};img.src=window.URL.createObjectURL(blob);},hideFocusRing:function camera_hideFocusRing(){this.focusRing.removeAttribute('data-state');},checkStorageSpace:function camera_checkStorageSpace(){if(this.updateOverlay()){return;}
if(this._storageState===this.STORAGE_INIT){this._pictureStorage.available().onsuccess=(function(e){this.updateStorageState(e.target.result);this.updateOverlay();this.checkStorageSpace();}.bind(this));return;}
var MAX_IMAGE_SIZE=(this._pictureSize.width*this._pictureSize.height*4)+4096;this._pictureStorage.freeSpace().onsuccess=(function(e){if(e.target.result<MAX_IMAGE_SIZE){this._storageState=this.STORAGE_CAPACITY;}
this.updateOverlay();}).bind(this);},deviceStorageChangeHandler:function camera_deviceStorageChangeHandler(e){switch(e.reason){case'available':case'unavailable':case'shared':this.updateStorageState(e.reason);break;case'deleted':Filmstrip.deleteItem(e.path);break;}
this.checkStorageSpace();},updateStorageState:function camera_updateStorageState(state){switch(state){case'available':this._storageState=this.STORAGE_AVAILABLE;break;case'unavailable':this._storageState=this.STORAGE_NOCARD;break;case'shared':this._storageState=this.STORAGE_UNMOUNTED;break;}},updateOverlay:function camera_updateOverlay(){if(this._storageState===this.STORAGE_INIT){return false;}
if(this._storageState===this.STORAGE_AVAILABLE){if(!this._previewActive&&!document.mozHidden){this.startPreview();}
this.showOverlay(null);return false;}
switch(this._storageState){case this.STORAGE_NOCARD:this.showOverlay('nocard');break;case this.STORAGE_UNMOUNTED:this.showOverlay('pluggedin');break;case this.STORAGE_CAPACITY:this.showOverlay('nospace2');break;}
if(this._previewActive){this.stopPreview();}
return true;},prepareTakePicture:function camera_takePicture(){this.disableButtons();this.focusRing.setAttribute('data-state','focusing');if(this._autoFocusSupported&&!this._manuallyFocused){this._cameraObj.autoFocus(this.autoFocusDone.bind(this));}else{this.takePicture();}},autoFocusDone:function camera_autoFocusDone(success){if(!success){this.enableButtons();this.focusRing.setAttribute('data-state','fail');window.setTimeout(this.hideFocusRing.bind(this),1000);return;}
this.focusRing.setAttribute('data-state','focused');this.takePicture();},takePicture:function camera_takePicture(){this._config.rotation=this._phoneOrientation;this._config.pictureSize=this._pictureSize;this._config.dateTime=Date.now()/1000;if(this._position&&!this._pendingPick){this._config.position=this._position;}
this._cameraObj.takePicture(this._config,this.takePictureSuccess.bind(this));},showOverlay:function camera_showOverlay(id){this._currentOverlay=id;if(id===null){this.overlay.classList.add('hidden');return;}
this.overlayTitle.textContent=navigator.mozL10n.get(id+'-title');this.overlayText.textContent=navigator.mozL10n.get(id+'-text');this.overlay.classList.remove('hidden');},pickPictureSize:function camera_pickPictureSize(pictureSizes){var maxRes=this.MAX_IMAGE_RES;var size=pictureSizes.reduce(function(acc,size){var mp=size.width*size.height;return(mp>acc.width*acc.height&&mp<=maxRes)?size:acc;},{width:0,height:0});if(size.width===0&&size.height===0){return pictureSizes[0];}else{return size;}},initPositionUpdate:function camera_initPositionUpdate(){if(this._watchId||document.mozHidden){return;}
this._watchId=navigator.geolocation.watchPosition(this.updatePosition.bind(this));},updatePosition:function camera_updatePosition(position){this._position={timestamp:position.timestamp,altitude:position.coords.altitude,latitude:position.coords.latitude,longitude:position.coords.longitude};},cancelPositionUpdate:function camera_cancelPositionUpdate(){navigator.geolocation.clearWatch(this._watchId);this._watchId=null;},release:function camera_release(callback){if(!this._cameraObj)
return;this._cameraObj.release(function cameraReleased(){Camera._cameraObj=null;if(callback)
callback.call(Camera);},function releaseError(){console.warn('Camera: failed to release hardware?');if(callback)
callback.call(Camera);});}};Camera.init();document.addEventListener('mozvisibilitychange',function(){if(document.mozHidden){Camera.stopPreview();Camera.cancelPick();Camera.cancelPositionUpdate();if(this._secureMode)
Filmstrip.clear();}else{Camera.startPreview();}});window.addEventListener('beforeunload',function(){window.clearTimeout(Camera._timeoutId);delete Camera._timeoutId;Camera.viewfinder.mozSrcObject=null;});